c     This subroutine gives the matrix element squared for
c     h -> W-W+ -> e-  nubar_e  mu+ nu_mu
c                  mu- nubar_mu e+  nu_e
c     
c fermion 1:  neutrino
c fermion 2:  + lepton
c fermion 3:  - lepton
c fermion 4:  anti-neutrino

      subroutine m2s_WW( L, m2s)
      implicit none
#include "VBFNLO/utilities/global.inc"
c      include 'koppln.inc'
      real*8 gfermil
      parameter (gfermil = 1.16639d-5)
      real*8 L(0:3,4)           !lepton 4-mom
      real*8 m2s                !matrix element squared
      real*8 XM2s(6),XMGs(6)
      COMMON /BKOPOUshort/ XM2s,XMGs
      real*8 prop2(2),Q(0:4,2),p13,p24
      integer mu,i
c
      p13 = l(0,1)*l(0,3) - l(1,1)*l(1,3) - l(2,1)*l(2,3)- l(3,1)*l(3,3)
      p24 = l(0,2)*l(0,4) - l(1,2)*l(1,4) - l(2,2)*l(2,4)- l(3,2)*l(3,4)

      do mu = 0,3
         Q(mu,1) = l(mu,1) + l(mu,2)
         Q(mu,2) = l(mu,3) + l(mu,4)
      enddo
      do i = 1,2
         Q(4,i) = Q(0,i)**2 -  Q(1,i)**2 - Q(2,i)**2 - Q(3,i)**2
c
         prop2(i) = 1.0d0/((Q(4,i) - xm2s(3))**2 + xmgs(3)**2) !*Q(4,i)/xm2s(3))
      enddo
      
      m2s = p13 * p24 * prop2(1) * prop2(2)
      m2s = m2s * 1024.0d0 * xm2s(3)**4 * gfermil**3/sqrt(2.0d0)

      m2s = m2s !* 2.0d0         !sum over two subprocesses     
      return
      end


      
