c
c in this file leptonic tensors needed for qq -> WWZ, WWZ -> 6l
c are computed for specific helicities (h)
c
c ------------------------------------------------------------
c ------------------------------------------------------------

      subroutine ATOWWZ(P,N,h,wwz,NW)

      IMPLICIT NONE

      DOUBLE PRECISION P(0:3,2:7)
      complex*16 wwz(0:5)
      integer lsign(2:7,2),ll,mu,nu,h,N
      integer NW ! = 0: all diagrams, = 1: no non resonant diagrams

      ! possible lepton helicities:
      data (lsign(ll,1),ll=2,7) / -1, -1, -1, -1, -1, -1/  !h=1
      data (lsign(ll,2),ll=2,7) / -1, -1, -1, -1, +1, +1/  !h=2

      call ATOWWZ1(P,N,lsign(2,h),wwz(0),NW)

      ! helicity combi nr.h is selected

      end

c ------------------------------------------------------------

      SUBROUTINE ATOWWZ1(P,N,lsign,wwz,NW)
C
C Generated by MadGraph II Version 3.0. Updated 02/19/04
C RETURNS AMPLITUDE SQUARED SUMMED/AVG OVER COLORS
C FOR THE POINT WITH EXTERNAL LINES W(0:6,NEXTERNAL)
C
C FOR PROCESS : a -> ve e+ mu- vm~ ta- ta+ 
C
      IMPLICIT NONE
C
C CONSTANTS
C
      INTEGER    NGRAPHS
      PARAMETER (NGRAPHS=  60)
      INTEGER    NWAVEFUNCS
      PARAMETER (NWAVEFUNCS=  74)
      DOUBLE PRECISION     ZERO
      PARAMETER (ZERO=0D0)
C
C ARGUMENTS
C
      DOUBLE PRECISION P(0:3,2:7), Q(0:3)
      INTEGER N
      COMPLEX*16 wwz(0:5)
      INTEGER lsign(2:7)
      integer NW ! = 0: all diagrams, = 1: no non resonant diagrams
C
C LOCAL VARIABLES
C
      INTEGER I,J, mu
      COMPLEX*16 AMP(NGRAPHS)
      COMPLEX*16 W(6,NWAVEFUNCS)

c  lepton spinors and W+-, Z/A polarization vectors
#include "tensor.inc"

      logical lswitch
      parameter (lswitch=.true.)

C
C GLOBAL VARIABLES
C
#include "VBFNLO/utilities/coupl.inc"
C
C ----------
C BEGIN CODE
C ----------
      if (lswitch) then      ! read in lepton an W states from common block
         do i=1,6
            w(i,2)  = wve(i,N)
            w(i,3)  = wep(i,N)
            w(i,4)  = wmu(i,N)
            w(i,5)  = wvm(i,N)
            w(i,6)  = ztm(i,N)
            w(i,7)  = ztp(i,N)
            w(i,8)  = wp(i,N)
            w(i,13) = wm(i,N)
            w(i,25) = atau(i,N)
            w(i,22) = ztau(i,N)
         enddo
      endif

      do mu = 0,3
         q(mu) = p(mu,2)+p(mu,3)+p(mu,4)+p(mu,5)+p(mu,6)+p(mu,7)
      enddo
c
      if (.not.lswitch) then
         CALL OXXXXX(P(0,2   ),ZERO , lsign(2),+1,W(1,2   )) !ve
         CALL IXXXXX(P(0,3   ),ZERO ,-lsign(3),-1,W(1,3   )) !e+
         CALL OXXXXX(P(0,4   ),ZERO , lsign(4),+1,W(1,4   )) !mu-
         CALL IXXXXX(P(0,5   ),ZERO ,-lsign(5),-1,W(1,5   )) !vm~
         CALL OXXXXX(P(0,6   ),LMASS , lsign(6),+1,W(1,6   )) !ta-
         CALL IXXXXX(P(0,7   ),LMASS ,-lsign(7),-1,W(1,7   )) !ta+
         CALL JIOXXX(W(1,3   ),W(1,2),GWF ,WMASS,WWIDTH ,W(1,8 )) !wp
         CALL JIOXXX(W(1,5   ),W(1,4),GWF ,WMASS,WWIDTH ,W(1,13)) !wm
         CALL JIOXXX(W(1,7   ),W(1,6),GZL ,ZMASS,ZWIDTH ,W(1,22)) !z
         CALL JIOXXX(W(1,7   ),W(1,6),GAL ,ZERO ,ZERO   ,W(1,25)) !a
c         print*," ve ",(wve(i,N)/w(i,2),i=1,6)
c         print*," ep ",(wep(i,N)/w(i,3),i=1,6)
c         print*," mu ",(wmu(i,N)/w(i,4),i=1,6)
c         print*," vm ",(wvm(i,N)/w(i,5),i=1,6)
c         print*," ta- ",(ztm(i,N)/w(i,6),i=1,6)
c         print*," ta+ ",(ztp(i,N)/w(i,7),i=1,6)
c         print*," wp ",(wp(i,N)/w(i,8),i=1,6)
c         print*," wm ",(wm(i,N)/w(i,13),i=1,6)
c         print*," a ",( atau(i,N)/w(i,25),i=1,6)
c         print*," z ",( ztau(i,N)/w(i,22),i=1,6)
      endif
      do mu = 0,3
      CALL TRIBOSVCARTX(Q(0),ZERO ,ZERO, MU,-1,W(1,1   )) 
      CALL FVOXXX(W(1,4   ),W(1,8   ),GWF ,ZERO    ,ZERO    ,W(1,9   ))    
      CALL JIOXXX(W(1,5   ),W(1,9   ),GZN ,ZMASS   ,ZWIDTH  ,W(1,10  ))    
      CALL FVOXXX(W(1,6   ),W(1,10  ),GZL ,LMASS   ,ZERO    ,W(1,11  ))    
      CALL IOVXXX(W(1,7   ),W(1,11  ),W(1,1   ),GAL ,AMP(1   ))            
      CALL FVOXXX(W(1,6   ),W(1,1   ),GAL ,LMASS   ,ZERO    ,W(1,12  ))    
      CALL IOVXXX(W(1,7   ),W(1,12  ),W(1,10  ),GZL ,AMP(2   ))             
      CALL FVIXXX(W(1,7   ),W(1,1   ),GAL ,LMASS   ,ZERO    ,W(1,14  ))    
      CALL JVVXXX(W(1,13  ),W(1,8   ),GWWA ,ZERO    ,ZERO    ,W(1,15))   
      CALL IOVXXX(W(1,14  ),W(1,6   ),W(1,15  ),GAL ,AMP(3   ))            
      CALL JVVXXX(W(1,13  ),W(1,8   ),GWWZ ,ZMASS   ,ZWIDTH  ,W(1,16))
      CALL IOVXXX(W(1,14  ),W(1,6   ),W(1,16  ),GZL ,AMP(4   ))            
      CALL HVVXXX(W(1,13  ),W(1,8   ),GWWH ,HMASS   ,HWIDTH  ,W(1,17))
      CALL IOSXXX(W(1,14  ),W(1,6   ),W(1,17  ),GHTAU ,AMP(5   ))          
      CALL FVIXXX(W(1,7   ),W(1,13  ),GWF ,ZERO    ,ZERO    ,W(1,18  ))    
      CALL IOVXXX(W(1,18  ),W(1,12  ),W(1,8   ),GWF ,AMP(6   ))            
      CALL JIOXXX(W(1,7   ),W(1,12  ),GAL ,ZERO    ,ZERO    ,W(1,19  ))    
      CALL VVVXXX(W(1,13  ),W(1,8   ),W(1,19  ),GWWA ,AMP(7   ))           
      CALL JIOXXX(W(1,7   ),W(1,12  ),GZL ,ZMASS   ,ZWIDTH  ,W(1,20  ))    
      CALL VVVXXX(W(1,13  ),W(1,8   ),W(1,20  ),GWWZ ,AMP(8   ))           
      CALL HIOXXX(W(1,7   ),W(1,12  ),GHTAU ,HMASS   ,HWIDTH  ,W(1,21))
      CALL VVSXXX(W(1,13  ),W(1,8   ),W(1,21  ),GWWH ,AMP(9   ))            
      CALL JVVXXX(W(1,1   ),W(1,13  ),GWWA ,WMASS   ,WWIDTH  ,W(1,23))
      CALL FVOXXX(W(1,2   ),W(1,22  ),GZN ,ZERO    ,ZERO    ,W(1,24  ))    
      CALL IOVXXX(W(1,3   ),W(1,24  ),W(1,23  ),GWF ,AMP(10  ))            
      CALL FVIXXX(W(1,3   ),W(1,25  ),GAL ,ZERO    ,ZERO    ,W(1,26  ))    
      CALL IOVXXX(W(1,26  ),W(1,2   ),W(1,23  ),GWF ,AMP(11  ))            
      CALL FVIXXX(W(1,3   ),W(1,22  ),GZL ,ZERO    ,ZERO    ,W(1,27  ))    
      CALL IOVXXX(W(1,27  ),W(1,2   ),W(1,23  ),GWF ,AMP(12  ))            
      CALL JVVXXX(W(1,8   ),W(1,1   ),GWWA ,WMASS   ,WWIDTH  ,W(1,28))
      CALL FVIXXX(W(1,5   ),W(1,28  ),GWF ,ZERO    ,ZERO    ,W(1,29  ))    
      CALL JIOXXX(W(1,29  ),W(1,4   ),GAL ,ZERO    ,ZERO    ,W(1,30  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,30  ),GAL ,AMP(13  ))            
      CALL JIOXXX(W(1,29  ),W(1,4   ),GZL ,ZMASS   ,ZWIDTH  ,W(1,31  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,31  ),GZL ,AMP(14  ))            
      CALL FVOXXX(W(1,4   ),W(1,28  ),GWF ,ZERO    ,ZERO    ,W(1,32  ))    
      CALL JIOXXX(W(1,5   ),W(1,32  ),GZN ,ZMASS   ,ZWIDTH  ,W(1,33  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,33  ),GZL ,AMP(15  ))            
      CALL FVOXXX(W(1,6   ),W(1,8   ),GWF ,ZERO    ,ZERO    ,W(1,34  ))    
      CALL IOVXXX(W(1,14  ),W(1,34  ),W(1,13  ),GWF ,AMP(16  ))            
      CALL VVVXXX(W(1,23  ),W(1,8   ),W(1,25  ),GWWA ,AMP(17  ))           
      CALL VVVXXX(W(1,23  ),W(1,8   ),W(1,22  ),GWWZ ,AMP(18  ))           
      CALL HIOXXX(W(1,7   ),W(1,6   ),GHTAU ,HMASS   ,HWIDTH  ,W(1,35))
      CALL VVSXXX(W(1,23  ),W(1,8   ),W(1,35  ),GWWH ,AMP(19  ))           
      CALL JIOXXX(W(1,7   ),W(1,34  ),GWF ,WMASS   ,WWIDTH  ,W(1,36  ))    
      CALL VVVXXX(W(1,13  ),W(1,36  ),W(1,1   ),GWWA ,AMP(20  ))           
      CALL JVVXXX(W(1,13  ),W(1,28  ),GWWA ,ZERO    ,ZERO    ,W(1,37))
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,37  ),GAL ,AMP(21  ))            
      CALL JVVXXX(W(1,13  ),W(1,28  ),GWWZ ,ZMASS   ,ZWIDTH  ,W(1,38))
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,38  ),GZL ,AMP(22  ))            
      CALL HVVXXX(W(1,13  ),W(1,28  ),GWWH ,HMASS   ,HWIDTH  ,W(1,39))
      CALL IOSXXX(W(1,7   ),W(1,6   ),W(1,39  ),GHTAU ,AMP(23  ))          
      CALL FVOXXX(W(1,6   ),W(1,28  ),GWF ,ZERO    ,ZERO    ,W(1,40  ))    
      CALL IOVXXX(W(1,7   ),W(1,40  ),W(1,13  ),GWF ,AMP(24  ))            
      CALL W3W3XX(W(1,13  ),W(1,1   ),W(1,8   ),W(1,25  ),GWWA ,GWWA ,AMP(25))
      CALL W3W3XX(W(1,13  ),W(1,22  ),W(1,8   ),W(1,1),GWWZ ,GWWA ,AMP(26))
      CALL FVIXXX(W(1,5   ),W(1,8   ),GWF ,ZERO    ,ZERO    ,W(1,41  ))    
      CALL JIOXXX(W(1,41  ),W(1,4   ),GAL ,ZERO    ,ZERO    ,W(1,42  ))    
      CALL IOVXXX(W(1,14  ),W(1,6   ),W(1,42  ),GAL ,AMP(27  ))            
      CALL JIOXXX(W(1,41  ),W(1,4   ),GZL ,ZMASS   ,ZWIDTH  ,W(1,43  ))    
      CALL IOVXXX(W(1,14  ),W(1,6   ),W(1,43  ),GZL ,AMP(28  ))            
      CALL IOVXXX(W(1,41  ),W(1,4   ),W(1,19  ),GAL ,AMP(29  ))            
      CALL IOVXXX(W(1,41  ),W(1,4   ),W(1,20  ),GZL ,AMP(30  ))            
      CALL FVOXXX(W(1,4   ),W(1,1   ),GAL ,ZERO    ,ZERO    ,W(1,44  ))    
      CALL JIOXXX(W(1,5   ),W(1,44  ),GWF ,WMASS   ,WWIDTH  ,W(1,45  ))    
      CALL FVIXXX(W(1,3   ),W(1,45  ),GWF ,ZERO    ,ZERO    ,W(1,46  ))    
      CALL IOVXXX(W(1,46  ),W(1,2   ),W(1,22  ),GZN ,AMP(31  ))            
      CALL FVOXXX(W(1,2   ),W(1,45  ),GWF ,ZERO    ,ZERO    ,W(1,47  ))    
      CALL IOVXXX(W(1,3   ),W(1,47  ),W(1,25  ),GAL ,AMP(32  ))            
      CALL IOVXXX(W(1,3   ),W(1,47  ),W(1,22  ),GZL ,AMP(33  ))            
      CALL FVIXXX(W(1,41  ),W(1,1   ),GAL ,ZERO    ,ZERO    ,W(1,48  ))    
      CALL IOVXXX(W(1,48  ),W(1,4   ),W(1,25  ),GAL ,AMP(34  ))            
      CALL IOVXXX(W(1,48  ),W(1,4   ),W(1,22  ),GZL ,AMP(35  ))            
      CALL FVOXXX(W(1,44  ),W(1,8   ),GWF ,ZERO    ,ZERO    ,W(1,49  ))    
      CALL JIOXXX(W(1,5   ),W(1,49  ),GZN ,ZMASS   ,ZWIDTH  ,W(1,50  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,50  ),GZL ,AMP(36  ))            
      CALL JIOXXX(W(1,41  ),W(1,44  ),GAL ,ZERO    ,ZERO    ,W(1,51  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,51  ),GAL ,AMP(37  ))            
      CALL JIOXXX(W(1,41  ),W(1,44  ),GZL ,ZMASS   ,ZWIDTH  ,W(1,52  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,52  ),GZL ,AMP(38  ))            
      CALL JVVXXX(W(1,45  ),W(1,8   ),GWWA ,ZERO    ,ZERO    ,W(1,53  )) 
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,53  ),GAL ,AMP(39  ))            
      CALL JVVXXX(W(1,45  ),W(1,8   ),GWWZ ,ZMASS   ,ZWIDTH  ,W(1,54  ))
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,54  ),GZL ,AMP(40  ))            
      CALL HVVXXX(W(1,45  ),W(1,8   ),GWWH ,HMASS   ,HWIDTH  ,W(1,55  ))
      CALL IOSXXX(W(1,7   ),W(1,6   ),W(1,55  ),GHTAU ,AMP(41  ))          
      CALL IOVXXX(W(1,7   ),W(1,34  ),W(1,45  ),GWF ,AMP(42  ))            
      CALL FVOXXX(W(1,2   ),W(1,13  ),GWF ,ZERO    ,ZERO    ,W(1,56  ))    
      CALL JIOXXX(W(1,14  ),W(1,6   ),GAL ,ZERO    ,ZERO    ,W(1,57  ))    
      CALL IOVXXX(W(1,3   ),W(1,56  ),W(1,57  ),GAL ,AMP(43  ))            
      CALL JIOXXX(W(1,14  ),W(1,6   ),GZL ,ZMASS   ,ZWIDTH  ,W(1,58  ))    
      CALL IOVXXX(W(1,3   ),W(1,56  ),W(1,58  ),GZL ,AMP(44  ))            
      CALL FVIXXX(W(1,3   ),W(1,19  ),GAL ,ZERO    ,ZERO    ,W(1,59  ))    
      CALL IOVXXX(W(1,59  ),W(1,2   ),W(1,13  ),GWF ,AMP(45  ))            
      CALL FVIXXX(W(1,3   ),W(1,20  ),GZL ,ZERO    ,ZERO    ,W(1,60  ))    
      CALL IOVXXX(W(1,60  ),W(1,2   ),W(1,13  ),GWF ,AMP(46  ))            
      CALL FVIXXX(W(1,3   ),W(1,1   ),GAL ,ZERO    ,ZERO    ,W(1,61  ))    
      CALL FVIXXX(W(1,61  ),W(1,13  ),GWF ,ZERO    ,ZERO    ,W(1,62  ))    
      CALL IOVXXX(W(1,62  ),W(1,2   ),W(1,22  ),GZN ,AMP(47  ))            
      CALL IOVXXX(W(1,26  ),W(1,56  ),W(1,1   ),GAL ,AMP(48  ))            
      CALL IOVXXX(W(1,27  ),W(1,56  ),W(1,1   ),GAL ,AMP(49  ))            
      CALL JIOXXX(W(1,61  ),W(1,2   ),GWF ,WMASS   ,WWIDTH  ,W(1,63  ))    
      CALL FVIXXX(W(1,5   ),W(1,63  ),GWF ,ZERO    ,ZERO    ,W(1,64  ))    
      CALL JIOXXX(W(1,64  ),W(1,4   ),GAL ,ZERO    ,ZERO    ,W(1,65  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,65  ),GAL ,AMP(50  ))            
      CALL JIOXXX(W(1,64  ),W(1,4   ),GZL ,ZMASS   ,ZWIDTH  ,W(1,66  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,66  ),GZL ,AMP(51  ))            
      CALL FVOXXX(W(1,4   ),W(1,63  ),GWF ,ZERO    ,ZERO    ,W(1,67  ))    
      CALL JIOXXX(W(1,5   ),W(1,67  ),GZN ,ZMASS   ,ZWIDTH  ,W(1,68  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,68  ),GZL ,AMP(52  ))            
      CALL IOVXXX(W(1,61  ),W(1,56  ),W(1,25  ),GAL ,AMP(53  ))            
      CALL IOVXXX(W(1,61  ),W(1,56  ),W(1,22  ),GZL ,AMP(54  ))            
      CALL JVVXXX(W(1,13  ),W(1,63  ),GWWA ,ZERO    ,ZERO    ,W(1,69  ))
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,69  ),GAL ,AMP(55  ))            
      CALL JVVXXX(W(1,13  ),W(1,63  ),GWWZ ,ZMASS   ,ZWIDTH  ,W(1,70  ))   
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,70  ),GZL ,AMP(56  ))            
      CALL HVVXXX(W(1,13  ),W(1,63  ),GWWH ,HMASS   ,HWIDTH  ,W(1,71  ))  
      CALL IOSXXX(W(1,7   ),W(1,6   ),W(1,71  ),GHTAU ,AMP(57  ))          
      CALL FVOXXX(W(1,6   ),W(1,63  ),GWF ,ZERO    ,ZERO    ,W(1,72  ))    
      CALL IOVXXX(W(1,7   ),W(1,72  ),W(1,13  ),GWF ,AMP(58  ))            
      CALL FVIXXX(W(1,3   ),W(1,13  ),GWF ,ZERO    ,ZERO    ,W(1,73  ))    
      CALL IOVXXX(W(1,73  ),W(1,2   ),W(1,58  ),GZN ,AMP(59  ))            
      CALL FVOXXX(W(1,2   ),W(1,20  ),GZN ,ZERO    ,ZERO    ,W(1,74  ))    
      CALL IOVXXX(W(1,3   ),W(1,74  ),W(1,13  ),GWF ,AMP(60  ))    
      if (NW.eq.0) then        
      wwz(mu) =    -AMP(   1)-AMP(   2)-AMP(   3)-AMP(   4)-AMP(   6) !non
     &             -AMP(   7)-AMP(   8)-AMP(  10)-AMP(  11)-AMP(  12) !resonant
     &             -AMP(  13)-AMP(  14)-AMP(  15)-AMP(  16)-AMP(  20) !
     &             -AMP(  24)-AMP(  27)-AMP(  28)-AMP(  29)-AMP(  30) !non
     &             -AMP(  31)-AMP(  32)-AMP(  33)-AMP(  34)-AMP(  35) !resonant
     &             -AMP(  36)-AMP(  37)-AMP(  38)-AMP(  39)-AMP(  40) !
     &             -AMP(  42)-AMP(  43)-AMP(  44)-AMP(  45)-AMP(  46) !non
     &             -AMP(  47)-AMP(  48)-AMP(  49)-AMP(  50)-AMP(  51) !resonant
     &             -AMP(  52)-AMP(  53)-AMP(  54)-AMP(  55)-AMP(  56) !
     &             -AMP(  58)-AMP(  59)-AMP(  60)                     !non r.
     &             -AMP(  17)-AMP(  18)-AMP(  21)-AMP(  22)-AMP(  25)
     &             -AMP(  26)
c     &            -AMP(   5)-AMP(   9)-AMP(  19)-AMP(  23)-AMP(  41) !H -> tau
c     &            -AMP(  57)                                         !H -> tau
      else if (NW.eq.1) then
      wwz(mu) =    -AMP(  18)-AMP(  22)-AMP(  26)
      endif
      enddo
      wwz(4) = dcmplx(q(0),q(3))
      wwz(5) = dcmplx(q(1),q(2))
c
      END


c ------------------------------------------------------------

      subroutine ZTOWWZ(P,N,h,wwz,NW)

      IMPLICIT NONE

      DOUBLE PRECISION P(0:3,2:7)
      complex*16 wwz(0:5)
      integer lsign(2:7,2),ll,mu,nu,h,N
      integer NW ! = 0: all diagrams, = 1: no non resonant diagrams

      ! possible lepton helicities:
      data (lsign(ll,1),ll=2,7) / -1, -1, -1, -1, -1, -1/  !h=1
      data (lsign(ll,2),ll=2,7) / -1, -1, -1, -1, +1, +1/  !h=2

      call ZTOWWZ1(P,N,lsign(2,h),wwz(0),NW)

      ! helicity combi nr.h is selected

      end

c ------------------------------------------------------------

      SUBROUTINE ZTOWWZ1(P,N,lsign,wwz,NW)
C
C Generated by MadGraph II Version 3.0. Updated 02/19/04
C RETURNS AMPLITUDE SQUARED SUMMED/AVG OVER COLORS
C FOR THE POINT WITH EXTERNAL LINES W(0:6,NEXTERNAL)
C
C FOR PROCESS : z -> ve e+ mu- vm~ ta- ta+ 
C
      IMPLICIT NONE
C
C CONSTANTS
C
      INTEGER    NGRAPHS
      PARAMETER (NGRAPHS=  89)
      INTEGER    NWAVEFUNCS
      PARAMETER (NWAVEFUNCS=  94)
      DOUBLE PRECISION     ZERO
      PARAMETER (ZERO=0D0)
C
C ARGUMENTS
C
      DOUBLE PRECISION P(0:3,2:7), Q(0:3)
      INTEGER N
      COMPLEX*16 wwz(0:5)
      INTEGER lsign(2:7)
      integer NW ! = 0: all diagrams, = 1: no non resonant diagrams
C
C LOCAL VARIABLES
C
      INTEGER I,J, mu
      COMPLEX*16 AMP(NGRAPHS)
      COMPLEX*16 W(6,NWAVEFUNCS)

c  lepton spinors and W+-, Z/A polarization vectors
#include "tensor.inc"

      logical lswitch
      parameter (lswitch=.true.)

C
C GLOBAL VARIABLES
C
#include "VBFNLO/utilities/coupl.inc"
C
C ----------
C BEGIN CODE
C ----------
      if (lswitch) then      ! read in lepton an W states from common block
         do i=1,6
            w(i,2)  = wve(i,N)
            w(i,3)  = wep(i,N)
            w(i,4)  = wmu(i,N)
            w(i,5)  = wvm(i,N)
            w(i,6)  = ztm(i,N)
            w(i,7)  = ztp(i,N)
            w(i,8)  = wp(i,N)
            w(i,28) = wm(i,N)
            w(i,18) = atau(i,N)
            w(i,15) = ztau(i,N)
         enddo
      endif

      do mu = 0,3
         q(mu) = p(mu,2)+p(mu,3)+p(mu,4)+p(mu,5)+p(mu,6)+p(mu,7)
      enddo
c
      if (.not.lswitch) then
         CALL OXXXXX(P(0,2   ),ZERO , lsign(2),+1,W(1,2   )) !ve
         CALL IXXXXX(P(0,3   ),ZERO ,-lsign(3),-1,W(1,3   )) !e+
         CALL OXXXXX(P(0,4   ),ZERO , lsign(4),+1,W(1,4   )) !mu-
         CALL IXXXXX(P(0,5   ),ZERO ,-lsign(5),-1,W(1,5   )) !vm~
         CALL OXXXXX(P(0,6   ),LMASS , lsign(6),+1,W(1,6   )) !ta-
         CALL IXXXXX(P(0,7   ),LMASS ,-lsign(7),-1,W(1,7   )) !ta+
         CALL JIOXXX(W(1,3   ),W(1,2),GWF ,WMASS,WWIDTH ,W(1,8 )) !wp
         CALL JIOXXX(W(1,5   ),W(1,4),GWF ,WMASS,WWIDTH ,W(1,28)) !wm
         CALL JIOXXX(W(1,7   ),W(1,6),GZL ,ZMASS,ZWIDTH ,W(1,15)) !ztau
         CALL JIOXXX(W(1,7   ),W(1,6),GAL ,ZERO ,ZERO   ,W(1,18)) !atau
c         print*," ve ",(wve(i,N)/w(i,2),i=1,6)
c         print*," ep ",(wep(i,N)/w(i,3),i=1,6)
c         print*," mu ",(wmu(i,N)/w(i,4),i=1,6)
c         print*," vm ",(wvm(i,N)/w(i,5),i=1,6)
c         print*," ta- ",(ztm(i,N)/w(i,6),i=1,6)
c         print*," ta+ ",(ztp(i,N)/w(i,7),i=1,6)
c         print*," wp ",(wp(i,N)/w(i,8),i=1,6)
c         print*," wm ",(wm(i,N)/w(i,28),i=1,6)
c         print*," a ",( atau(i,N)/w(i,18),i=1,6)
c         print*," z ",( ztau(i,N)/w(i,15),i=1,6)
      endif
      do mu = 0,3
      CALL TRIBOSVCARTX(Q(0),ZMASS ,ZWIDTH, MU,-1,W(1,1   ))
c      CALL VXXXXX(P(0,1   ),ZERO ,NHEL(1   ),-1*IC(1   ),W(1,1   ))
c      CALL IXXXXX(P(0,2   ),ZERO ,NHEL(2   ),-1*IC(2   ),W(1,2   ))
c      CALL OXXXXX(P(0,3   ),ZERO ,NHEL(3   ),+1*IC(3   ),W(1,3   ))
c      CALL OXXXXX(P(0,4   ),ZERO ,NHEL(4   ),+1*IC(4   ),W(1,4   ))
c      CALL IXXXXX(P(0,5   ),ZERO ,NHEL(5   ),-1*IC(5   ),W(1,5   ))
c      CALL IXXXXX(P(0,6   ),LMASS ,NHEL(6   ),-1*IC(6   ),W(1,6   ))
c      CALL OXXXXX(P(0,7   ),LMASS ,NHEL(7   ),+1*IC(7   ),W(1,7   ))
c      CALL JIOXXX(W(1,3   ),W(1,2   ),GWF ,WMASS   ,WWIDTH  ,W(1,8   ))  !wp  
      CALL FVOXXX(W(1,4   ),W(1,8   ),GWF ,ZERO    ,ZERO    ,W(1,9   ))    
      CALL JIOXXX(W(1,5   ),W(1,9   ),GZN ,ZMASS   ,ZWIDTH  ,W(1,10  ))    
      CALL FVOXXX(W(1,6   ),W(1,10  ),GZL ,LMASS   ,ZERO    ,W(1,11  ))       
      CALL IOVXXX(W(1,7   ),W(1,11  ),W(1,1   ),GZL ,AMP(1   ))            
      CALL HVVXXX(W(1,10  ),W(1,1   ),GZZH ,HMASS   ,HWIDTH  ,W(1,         
     &     12  ))                                                          
      CALL IOSXXX(W(1,7   ),W(1,6   ),W(1,12  ),GHTAU ,AMP(2   ))
      CALL FVOXXX(W(1,6   ),W(1,1   ),GZL ,LMASS   ,ZERO    ,W(1,13  ))      
      CALL IOVXXX(W(1,7   ),W(1,13  ),W(1,10  ),GZL ,AMP(3   ))            
      CALL FVIXXX(W(1,5   ),W(1,1   ),GZN ,ZERO    ,ZERO    ,W(1,14  ))    
c      CALL JIOXXX(W(1,7   ),W(1,6   ),GZL ,ZMASS   ,ZWIDTH  ,W(1,15  ))  !ztau
      CALL JIOXXX(W(1,14  ),W(1,4   ),GWF ,WMASS   ,WWIDTH  ,W(1,16  ))    
      CALL FVOXXX(W(1,2   ),W(1,15  ),GZN ,ZERO    ,ZERO    ,W(1,17  ))    
      CALL IOVXXX(W(1,3   ),W(1,17  ),W(1,16  ),GWF ,AMP(4   ))            
c      CALL JIOXXX(W(1,7   ),W(1,6   ),GAL ,ZERO    ,ZERO    ,W(1,18  ))  !atau
      CALL FVIXXX(W(1,3   ),W(1,18  ),GAL ,ZERO    ,ZERO    ,W(1,19  ))    
      CALL IOVXXX(W(1,19  ),W(1,2   ),W(1,16  ),GWF ,AMP(5   ))            
      CALL FVIXXX(W(1,3   ),W(1,15  ),GZL ,ZERO    ,ZERO    ,W(1,20  ))    
      CALL IOVXXX(W(1,20  ),W(1,2   ),W(1,16  ),GWF ,AMP(6   ))            
      CALL FVIXXX(W(1,14  ),W(1,8   ),GWF ,ZERO    ,ZERO    ,W(1,21  ))    
      CALL IOVXXX(W(1,21  ),W(1,4   ),W(1,18  ),GAL ,AMP(7   ))            
      CALL IOVXXX(W(1,21  ),W(1,4   ),W(1,15  ),GZL ,AMP(8   ))            
      CALL FVOXXX(W(1,9   ),W(1,1   ),GZN ,ZERO    ,ZERO    ,W(1,22  ))    
      CALL JIOXXX(W(1,5   ),W(1,22  ),GZN ,ZMASS   ,ZWIDTH  ,W(1,23  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,23  ),GZL ,AMP(9   ))            
      CALL VVVXXX(W(1,16  ),W(1,8   ),W(1,18  ),GWWA ,AMP(10  ))           
      CALL VVVXXX(W(1,16  ),W(1,8   ),W(1,15  ),GWWZ ,AMP(11  ))           
      CALL HIOXXX(W(1,7   ),W(1,6   ),GHTAU ,HMASS   ,HWIDTH  ,W(1,        
     &     24  ))                                                          
      CALL VVSXXX(W(1,16  ),W(1,8   ),W(1,24  ),GWWH ,AMP(12  ))           
      CALL FVOXXX(W(1,6   ),W(1,8   ),GWF ,ZERO    ,ZERO    ,W(1,25  ))    
      CALL JIOXXX(W(1,7   ),W(1,25  ),GWF ,WMASS   ,WWIDTH  ,W(1,26  ))    
      CALL IOVXXX(W(1,14  ),W(1,4   ),W(1,26  ),GWF ,AMP(13  ))            
      CALL JIOXXX(W(1,14  ),W(1,9   ),GZN ,ZMASS   ,ZWIDTH  ,W(1,27  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,27  ),GZL ,AMP(14  ))            
c      CALL JIOXXX(W(1,5   ),W(1,4   ),GWF ,WMASS   ,WWIDTH  ,W(1,28  ))  !wm
      CALL FVIXXX(W(1,7   ),W(1,1   ),GZL ,LMASS   ,ZERO    ,W(1,29  ))      
      CALL JVVXXX(W(1,28  ),W(1,8   ),GWWA ,ZERO    ,ZERO    ,W(1,         
     &     30  ))                                                          
      CALL IOVXXX(W(1,29  ),W(1,6   ),W(1,30  ),GAL ,AMP(15  ))            
      CALL JVVXXX(W(1,28  ),W(1,8   ),GWWZ ,ZMASS   ,ZWIDTH  ,W(1,         
     &     31  ))                                                          
      CALL IOVXXX(W(1,29  ),W(1,6   ),W(1,31  ),GZL ,AMP(16  ))            
      CALL HVVXXX(W(1,28  ),W(1,8   ),GWWH ,HMASS   ,HWIDTH  ,W(1,         
     &     32  ))                                                          
      CALL IOSXXX(W(1,29  ),W(1,6   ),W(1,32  ),GHTAU ,AMP(17  ))          
      CALL VVSXXX(W(1,15  ),W(1,1   ),W(1,32  ),GZZH ,AMP(18  ))           
      CALL VVSXXX(W(1,1   ),W(1,31  ),W(1,24  ),GZZH ,AMP(19  ))           
      CALL FVIXXX(W(1,7   ),W(1,28  ),GWF ,ZERO    ,ZERO    ,W(1,33  ))    
      CALL IOVXXX(W(1,33  ),W(1,13  ),W(1,8   ),GWF ,AMP(20  ))            
      CALL JIOXXX(W(1,7   ),W(1,13  ),GAL ,ZERO    ,ZERO    ,W(1,34  ))    
      CALL VVVXXX(W(1,28  ),W(1,8   ),W(1,34  ),GWWA ,AMP(21  ))           
      CALL JIOXXX(W(1,7   ),W(1,13  ),GZL ,ZMASS   ,ZWIDTH  ,W(1,35  ))    
      CALL VVVXXX(W(1,28  ),W(1,8   ),W(1,35  ),GWWZ ,AMP(22  ))           
      CALL HIOXXX(W(1,7   ),W(1,13  ),GHTAU ,HMASS   ,HWIDTH  ,W(1,        
     &     36  ))                                                          
      CALL VVSXXX(W(1,28  ),W(1,8   ),W(1,36  ),GWWH ,AMP(23  ))           
      CALL JVVXXX(W(1,1   ),W(1,28  ),GWWZ ,WMASS   ,WWIDTH  ,W(1,         
     &     37  ))                                                          
      CALL IOVXXX(W(1,3   ),W(1,17  ),W(1,37  ),GWF ,AMP(24  ))            
      CALL IOVXXX(W(1,19  ),W(1,2   ),W(1,37  ),GWF ,AMP(25  ))            
      CALL IOVXXX(W(1,20  ),W(1,2   ),W(1,37  ),GWF ,AMP(26  ))            
      CALL JVVXXX(W(1,8   ),W(1,1   ),GWWZ ,WMASS   ,WWIDTH  ,W(1,         
     &     38  ))                                                          
      CALL FVIXXX(W(1,5   ),W(1,38  ),GWF ,ZERO    ,ZERO    ,W(1,39  ))    
      CALL JIOXXX(W(1,39  ),W(1,4   ),GAL ,ZERO    ,ZERO    ,W(1,40  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,40  ),GAL ,AMP(27  ))            
      CALL JIOXXX(W(1,39  ),W(1,4   ),GZL ,ZMASS   ,ZWIDTH  ,W(1,41  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,41  ),GZL ,AMP(28  ))            
      CALL FVOXXX(W(1,4   ),W(1,38  ),GWF ,ZERO    ,ZERO    ,W(1,42  ))    
      CALL JIOXXX(W(1,5   ),W(1,42  ),GZN ,ZMASS   ,ZWIDTH  ,W(1,43  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,43  ),GZL ,AMP(29  ))            
      CALL IOVXXX(W(1,29  ),W(1,25  ),W(1,28  ),GWF ,AMP(30  ))            
      CALL VVVXXX(W(1,37  ),W(1,8   ),W(1,18  ),GWWA ,AMP(31  ))           
      CALL VVVXXX(W(1,37  ),W(1,8   ),W(1,15  ),GWWZ ,AMP(32  ))           
      CALL VVSXXX(W(1,37  ),W(1,8   ),W(1,24  ),GWWH ,AMP(33  ))           
      CALL VVVXXX(W(1,28  ),W(1,26  ),W(1,1   ),GWWZ ,AMP(34  ))           
      CALL IOVXXX(W(1,33  ),W(1,25  ),W(1,1   ),GZN ,AMP(35  ))            
      CALL JVVXXX(W(1,28  ),W(1,38  ),GWWA ,ZERO    ,ZERO    ,W(1,         
     &     44  ))                                                          
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,44  ),GAL ,AMP(36  ))            
      CALL JVVXXX(W(1,28  ),W(1,38  ),GWWZ ,ZMASS   ,ZWIDTH  ,W(1,         
     &     45  ))                                                          
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,45  ),GZL ,AMP(37  ))            
      CALL HVVXXX(W(1,28  ),W(1,38  ),GWWH ,HMASS   ,HWIDTH  ,W(1,         
     &     46  ))                                                          
      CALL IOSXXX(W(1,7   ),W(1,6   ),W(1,46  ),GHTAU ,AMP(38  ))          
      CALL FVOXXX(W(1,6   ),W(1,38  ),GWF ,ZERO    ,ZERO    ,W(1,47  ))    
      CALL IOVXXX(W(1,7   ),W(1,47  ),W(1,28  ),GWF ,AMP(39  ))            
      CALL W3W3XX(W(1,28  ),W(1,1   ),W(1,8   ),W(1,18  ),GWWZ ,GWWA ,     
     &     AMP(40  ))                                                      
      CALL W3W3XX(W(1,28  ),W(1,1   ),W(1,8   ),W(1,15  ),GWWZ ,GWWZ ,     
     &     AMP(41  ))                                                      
      CALL FVIXXX(W(1,5   ),W(1,8   ),GWF ,ZERO    ,ZERO    ,W(1,48  ))    
      CALL JIOXXX(W(1,48  ),W(1,4   ),GAL ,ZERO    ,ZERO    ,W(1,49  ))    
      CALL IOVXXX(W(1,29  ),W(1,6   ),W(1,49  ),GAL ,AMP(42  ))            
      CALL JIOXXX(W(1,48  ),W(1,4   ),GZL ,ZMASS   ,ZWIDTH  ,W(1,50  ))    
      CALL IOVXXX(W(1,29  ),W(1,6   ),W(1,50  ),GZL ,AMP(43  ))            
      CALL VVSXXX(W(1,1   ),W(1,50  ),W(1,24  ),GZZH ,AMP(44  ))           
      CALL IOVXXX(W(1,48  ),W(1,4   ),W(1,34  ),GAL ,AMP(45  ))            
      CALL IOVXXX(W(1,48  ),W(1,4   ),W(1,35  ),GZL ,AMP(46  ))            
      CALL FVOXXX(W(1,4   ),W(1,1   ),GZL ,ZERO    ,ZERO    ,W(1,51  ))    
      CALL JIOXXX(W(1,5   ),W(1,51  ),GWF ,WMASS   ,WWIDTH  ,W(1,52  ))    
      CALL FVIXXX(W(1,3   ),W(1,52  ),GWF ,ZERO    ,ZERO    ,W(1,53  ))    
      CALL IOVXXX(W(1,53  ),W(1,2   ),W(1,15  ),GZN ,AMP(47  ))            
      CALL FVOXXX(W(1,2   ),W(1,52  ),GWF ,ZERO    ,ZERO    ,W(1,54  ))    
      CALL IOVXXX(W(1,3   ),W(1,54  ),W(1,18  ),GAL ,AMP(48  ))            
      CALL IOVXXX(W(1,3   ),W(1,54  ),W(1,15  ),GZL ,AMP(49  ))            
      CALL FVIXXX(W(1,48  ),W(1,1   ),GZL ,ZERO    ,ZERO    ,W(1,55  ))    
      CALL IOVXXX(W(1,55  ),W(1,4   ),W(1,18  ),GAL ,AMP(50  ))            
      CALL IOVXXX(W(1,55  ),W(1,4   ),W(1,15  ),GZL ,AMP(51  ))            
      CALL FVOXXX(W(1,51  ),W(1,8   ),GWF ,ZERO    ,ZERO    ,W(1,56  ))    
      CALL JIOXXX(W(1,5   ),W(1,56  ),GZN ,ZMASS   ,ZWIDTH  ,W(1,57  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,57  ),GZL ,AMP(52  ))            
      CALL JIOXXX(W(1,48  ),W(1,51  ),GAL ,ZERO    ,ZERO    ,W(1,58  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,58  ),GAL ,AMP(53  ))            
      CALL JIOXXX(W(1,48  ),W(1,51  ),GZL ,ZMASS   ,ZWIDTH  ,W(1,59  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,59  ),GZL ,AMP(54  ))            
      CALL JVVXXX(W(1,52  ),W(1,8   ),GWWA ,ZERO    ,ZERO    ,W(1,         
     &     60  ))                                                          
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,60  ),GAL ,AMP(55  ))            
      CALL JVVXXX(W(1,52  ),W(1,8   ),GWWZ ,ZMASS   ,ZWIDTH  ,W(1,         
     &     61  ))                                                          
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,61  ),GZL ,AMP(56  ))            
      CALL HVVXXX(W(1,52  ),W(1,8   ),GWWH ,HMASS   ,HWIDTH  ,W(1,         
     &     62  ))                                                          
      CALL IOSXXX(W(1,7   ),W(1,6   ),W(1,62  ),GHTAU ,AMP(57  ))          
      CALL IOVXXX(W(1,7   ),W(1,25  ),W(1,52  ),GWF ,AMP(58  ))            
      CALL FVOXXX(W(1,2   ),W(1,28  ),GWF ,ZERO    ,ZERO    ,W(1,63  ))    
      CALL JIOXXX(W(1,29  ),W(1,6   ),GAL ,ZERO    ,ZERO    ,W(1,64  ))    
      CALL IOVXXX(W(1,3   ),W(1,63  ),W(1,64  ),GAL ,AMP(59  ))            
      CALL JIOXXX(W(1,29  ),W(1,6   ),GZL ,ZMASS   ,ZWIDTH  ,W(1,65  ))    
      CALL IOVXXX(W(1,3   ),W(1,63  ),W(1,65  ),GZL ,AMP(60  ))            
      CALL JVSXXX(W(1,1   ),W(1,24  ),GZZH ,ZMASS   ,ZWIDTH  ,W(1,         
     &     66  ))                                                          
      CALL IOVXXX(W(1,3   ),W(1,63  ),W(1,66  ),GZL ,AMP(61  ))            
      CALL FVIXXX(W(1,3   ),W(1,34  ),GAL ,ZERO    ,ZERO    ,W(1,67  ))    
      CALL IOVXXX(W(1,67  ),W(1,2   ),W(1,28  ),GWF ,AMP(62  ))            
      CALL FVIXXX(W(1,3   ),W(1,35  ),GZL ,ZERO    ,ZERO    ,W(1,68  ))    
      CALL IOVXXX(W(1,68  ),W(1,2   ),W(1,28  ),GWF ,AMP(63  ))            
      CALL FVIXXX(W(1,3   ),W(1,1   ),GZL ,ZERO    ,ZERO    ,W(1,69  ))    
      CALL FVIXXX(W(1,69  ),W(1,28  ),GWF ,ZERO    ,ZERO    ,W(1,70  ))    
      CALL IOVXXX(W(1,70  ),W(1,2   ),W(1,15  ),GZN ,AMP(64  ))            
      CALL IOVXXX(W(1,19  ),W(1,63  ),W(1,1   ),GZL ,AMP(65  ))            
      CALL IOVXXX(W(1,20  ),W(1,63  ),W(1,1   ),GZL ,AMP(66  ))            
      CALL JIOXXX(W(1,69  ),W(1,2   ),GWF ,WMASS   ,WWIDTH  ,W(1,71  ))    
      CALL FVIXXX(W(1,5   ),W(1,71  ),GWF ,ZERO    ,ZERO    ,W(1,72  ))    
      CALL JIOXXX(W(1,72  ),W(1,4   ),GAL ,ZERO    ,ZERO    ,W(1,73  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,73  ),GAL ,AMP(67  ))            
      CALL JIOXXX(W(1,72  ),W(1,4   ),GZL ,ZMASS   ,ZWIDTH  ,W(1,74  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,74  ),GZL ,AMP(68  ))            
      CALL FVOXXX(W(1,4   ),W(1,71  ),GWF ,ZERO    ,ZERO    ,W(1,75  ))    
      CALL JIOXXX(W(1,5   ),W(1,75  ),GZN ,ZMASS   ,ZWIDTH  ,W(1,76  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,76  ),GZL ,AMP(69  ))            
      CALL IOVXXX(W(1,69  ),W(1,63  ),W(1,18  ),GAL ,AMP(70  ))            
      CALL IOVXXX(W(1,69  ),W(1,63  ),W(1,15  ),GZL ,AMP(71  ))            
      CALL JVVXXX(W(1,28  ),W(1,71  ),GWWA ,ZERO    ,ZERO    ,W(1,         
     &     77  ))                                                          
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,77  ),GAL ,AMP(72  ))            
      CALL JVVXXX(W(1,28  ),W(1,71  ),GWWZ ,ZMASS   ,ZWIDTH  ,W(1,         
     &     78  ))                                                          
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,78  ),GZL ,AMP(73  ))            
      CALL HVVXXX(W(1,28  ),W(1,71  ),GWWH ,HMASS   ,HWIDTH  ,W(1,         
     &     79  ))                                                          
      CALL IOSXXX(W(1,7   ),W(1,6   ),W(1,79  ),GHTAU ,AMP(74  ))          
      CALL FVOXXX(W(1,6   ),W(1,71  ),GWF ,ZERO    ,ZERO    ,W(1,80  ))    
      CALL IOVXXX(W(1,7   ),W(1,80  ),W(1,28  ),GWF ,AMP(75  ))            
      CALL FVIXXX(W(1,3   ),W(1,28  ),GWF ,ZERO    ,ZERO    ,W(1,81  ))    
      CALL IOVXXX(W(1,81  ),W(1,2   ),W(1,65  ),GZN ,AMP(76  ))            
      CALL IOVXXX(W(1,81  ),W(1,2   ),W(1,66  ),GZN ,AMP(77  ))            
      CALL FVOXXX(W(1,2   ),W(1,35  ),GZN ,ZERO    ,ZERO    ,W(1,82  ))    
      CALL IOVXXX(W(1,3   ),W(1,82  ),W(1,28  ),GWF ,AMP(78  ))            
      CALL IOVXXX(W(1,81  ),W(1,17  ),W(1,1   ),GZN ,AMP(79  ))            
      CALL FVOXXX(W(1,2   ),W(1,1   ),GZN ,ZERO    ,ZERO    ,W(1,83  ))    
      CALL FVOXXX(W(1,83  ),W(1,28  ),GWF ,ZERO    ,ZERO    ,W(1,84  ))    
      CALL IOVXXX(W(1,3   ),W(1,84  ),W(1,18  ),GAL ,AMP(80  ))            
      CALL IOVXXX(W(1,3   ),W(1,84  ),W(1,15  ),GZL ,AMP(81  ))            
      CALL JIOXXX(W(1,3   ),W(1,83  ),GWF ,WMASS   ,WWIDTH  ,W(1,85  ))    
      CALL FVIXXX(W(1,5   ),W(1,85  ),GWF ,ZERO    ,ZERO    ,W(1,86  ))    
      CALL JIOXXX(W(1,86  ),W(1,4   ),GAL ,ZERO    ,ZERO    ,W(1,87  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,87  ),GAL ,AMP(82  ))            
      CALL JIOXXX(W(1,86  ),W(1,4   ),GZL ,ZMASS   ,ZWIDTH  ,W(1,88  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,88  ),GZL ,AMP(83  ))            
      CALL FVOXXX(W(1,4   ),W(1,85  ),GWF ,ZERO    ,ZERO    ,W(1,89  ))    
      CALL JIOXXX(W(1,5   ),W(1,89  ),GZN ,ZMASS   ,ZWIDTH  ,W(1,90  ))    
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,90  ),GZL ,AMP(84  ))            
      CALL IOVXXX(W(1,81  ),W(1,83  ),W(1,15  ),GZN ,AMP(85  ))            
      CALL JVVXXX(W(1,28  ),W(1,85  ),GWWA ,ZERO    ,ZERO    ,W(1,         
     &     91  ))                                                          
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,91  ),GAL ,AMP(86  ))            
      CALL JVVXXX(W(1,28  ),W(1,85  ),GWWZ ,ZMASS   ,ZWIDTH  ,W(1,         
     &     92  ))                                                          
      CALL IOVXXX(W(1,7   ),W(1,6   ),W(1,92  ),GZL ,AMP(87  ))            
      CALL HVVXXX(W(1,28  ),W(1,85  ),GWWH ,HMASS   ,HWIDTH  ,W(1,         
     &     93  ))                                                          
      CALL IOSXXX(W(1,7   ),W(1,6   ),W(1,93  ),GHTAU ,AMP(88  ))          
      CALL FVOXXX(W(1,6   ),W(1,85  ),GWF ,ZERO    ,ZERO    ,W(1,94  ))    
      CALL IOVXXX(W(1,7   ),W(1,94  ),W(1,28  ),GWF ,AMP(89  ))            
      if (NW.eq.0) then
      wwz(mu) =    -AMP(   1)-AMP(   3)-AMP(   4)-AMP(   5)-AMP(   6) !non
     &             -AMP(   7)-AMP(   8)-AMP(   9)-AMP(  10)-AMP(  11) !resonant
     &             -AMP(  13)-AMP(  14)-AMP(  15)-AMP(  16)-AMP(  20) !
     &             -AMP(  21)-AMP(  22)-AMP(  24)-AMP(  25)-AMP(  26) !non
     &             -AMP(  27)-AMP(  28)-AMP(  29)-AMP(  30)-AMP(  34) !resonant
     &             -AMP(  35)-AMP(  39)-AMP(  42)-AMP(  43)-AMP(  45) !
     &             -AMP(  46)-AMP(  47)-AMP(  48)-AMP(  49)-AMP(  50) !non
     &             -AMP(  51)-AMP(  52)-AMP(  53)-AMP(  54)-AMP(  55) !resonant
     &             -AMP(  56)-AMP(  58)-AMP(  59)-AMP(  60)-AMP(  62) !
     &             -AMP(  63)-AMP(  64)-AMP(  65)-AMP(  66)-AMP(  67) !non
     &             -AMP(  68)-AMP(  69)-AMP(  70)-AMP(  71)-AMP(  72) !resonant
     &             -AMP(  73)-AMP(  75)-AMP(  76)-AMP(  78)-AMP(  79) !
     &             -AMP(  80)-AMP(  81)-AMP(  82)-AMP(  83)-AMP(  84) !non
     &             -AMP(  85)-AMP(  86)-AMP(  87)-AMP(  89)           !resonant
     &             -AMP(  31)-AMP(  32)-AMP(  36)-AMP(  37)-AMP(  40)
     &             -AMP(  41)
     &             -AMP(  18)         !H -> WW contribution 
c     &            -AMP(   2)-AMP(  12)-AMP(  17)-AMP(  19)-AMP(  23) !H -> tau
c     &            -AMP(  33)-AMP(  38)-AMP(  44)-AMP(  57)-AMP(  61) !H -> tau
c     &            -AMP(  74)-AMP(  77)-AMP(  88)                     !H -> tau
      else if (NW.eq.1 ) then
      wwz(mu) =    -AMP(  32)-AMP(  37)-AMP(  41)
     &             -AMP(  18)         !H -> WW contribution 
      endif
      enddo
      wwz(4) = dcmplx(q(0),q(3))
      wwz(5) = dcmplx(q(1),q(2))
c
      END

c------------------------------------------------------------------------

      subroutine TRIBOSvcartx(p,vmass,vwidth,ncart,nsv , vc)
c
c This subroutine computes an effective VECTOR wavefunction for an internal
c vector boson line. The propagator is inlcuded in the Feynman gauge.
c
c input:
c       real    p(0:3)         : four-momentum of vector boson
c       real    vmass          : mass          of vector boson
c       integer ncart = 0,1,2,3: cartesian polarization direction
c                                of vector boson
c       integer nsv  = -1 or 1 : +1 for final, -1 for initial
c
c output:
c       complex vc(6)          : vector wavefunction       epsilon^mu(v)
c
      implicit none
      double complex vc(6), d
      double precision p(0:3),vmass,vwidth,q2
      integer ncart, mu, nsv

      q2 = p(0)**2-p(1)**2-p(2)**2-p(3)**2
      if (vmass.eq.0d0) then
         d = 1d0/q2
      else
         d = 1d0/dcmplx( q2-vmass**2, vmass*vwidth )
      endif
      do mu = 0,3
         vc(mu+1) = dcmplx(0d0,0d0)
      enddo
      if (ncart.eq.0) then
         vc(1) = d
      else
         vc(ncart+1) = -d
      endif
c
      vc(5) = dcmplx(p(0),p(3))*nsv
      vc(6) = dcmplx(p(1),p(2))*nsv
c
      return
      end
