c------------------------------------------------------------
c
c     Calculates Kaluza-Klein - STM Gauge Boson Couplings
c
c-------------------------------------------------------------
c
c      
      subroutine kk_coupl_inp_man
      
      implicit none
      
c
c  Local Variables
      integer i,j,k,l
      character*50 gtext
c 
c  Global Variables
#include "VBFNLO/utilities/coupl.inc"
#include "kkcoupl.inc"
      double precision CLR,XM2,XMG,B,V,A
      COMMON /BKOPOU/ CLR(4,5,-1:1),XM2(6),XMG(6),B(6,6,6),V(4,5),A(4,5)

      w1mass_k(0)=wmass
      z1mass_k(0)=zmass
      h1mass_k(0)=hmass
      a1mass_k(0)=0D0
      w1width_k(0)=wwidth
      z1width_k(0)=zwidth
      h1width_k(0)=hwidth
      gwwz_k(0,0,0)=gwwz
      gwwa_k(0,0,0)=gwwa
      hswitch=.false.
c 
c--------------------------------------------------------------------
c  Read in Parameters from kk_input.dat
c--------------------------------------------------------------------
      open (unit=50,file="kk_coupl_inp.dat")
      read(50,*) hswitchww
      read(50,*) hswitchwz
      read(50,*) hswitchzz
      read(50,*) kkhw
      read(50,*) kkhz
      read(50,*) kkha
      read(50,*) kkhh
c
      read (50,*) gtext
      read (50,*) gtext
      do i=1,kkhw
      read (50,*)  w1mass_k(i)
      enddo
c--------------------------------------------------------------------
      read (50,*) gtext
      do i=1,kkhz
      read (50,*)  z1mass_k(i)
      enddo
c--------------------------------------------------------------------
      read (50,*) gtext
      do i=1,kkha
      read (50,*)  a1mass_k(i)
      enddo
c--------------------------------------------------------------------
      if (hswitch) then
      read (50,*) gtext
      do i=0,kkhh
      read (50,*)  h1mass_k(i)
      read (50,*)  h1width_k(i)
      enddo
      endif
c--------------------------------------------------------------------
      read (50,*) gtext
      do i=0,kkhz
          read (50,*)  gwwz_k(0,0,i)
      enddo
      do i=1,kkhw
          do j=0,i
             do k=0,kkhz
              read (50,*)  gwwz_k(i,j,k) 
             enddo
          enddo
      enddo
c--------------------------------------------------------------------
      read (50,*) gtext
      do i=1,kkha
          read (50,*)  gwwa_k(0,0,i) 
      enddo
      do i=1,kkhw
          do j=0,i
             do k=0,kkha
              read (50,*)  gwwa_k(i,j,k)
             enddo
          enddo
      enddo
c--------------------------------------------------------------------
      if (hswitch) then
      read (50,*) gtext
      do i=0,kkhw
          do j=0,i
             do k=0,kkhh
              read (50,*)  gwwh_k(i,j,k) 
             enddo
          enddo
      enddo
      endif
c--------------------------------------------------------------------
      if (hswitch) then
      read (50,*) gtext
      do i=0,kkhz
          do j=0,i
             do k=0,kkhh
              read (50,*)  gzzh_k(i,j,k) 
             enddo
          enddo
      enddo
      endif
c--------------------------------------------------------------------
      read (50,*) gtext
      do i=0,kkhw
          do j=0,i
             do k=0,j
                do l=0,k
                  read (50,*)  gwwww_k(i,j,k,l)
                 enddo
             enddo
          enddo
      enddo
c--------------------------------------------------------------------
      read (50,*) gtext
      do k=0,kkhz
         do l=0,k
             read (50,*)  gwwzz_k(0,0,k,l) 
         enddo
      enddo
      do i=1,kkhw
          do j=0,i
             do k=0,kkhz
                do l=0,k
                  read (50,*)  gwwzz_k(i,j,k,l) 
                enddo
             enddo
          enddo
      enddo
c--------------------------------------------------------------------
      read (50,*) gtext
      do k=0,kkha
         do l=0,k
             read (50,*)  gwwaa_k(0,0,k,l)
         enddo
      enddo
      do i=1,kkhw
          do j=0,i
             do k=0,kkha
                do l=0,k
                  read (50,*)  gwwaa_k(i,j,k,l)
                 enddo
             enddo
          enddo
      enddo
c--------------------------------------------------------------------
      read (50,*) gtext
      do i=0,kkhw
          do j=0,i
             do k=0,kkha
                do l=0,kkhz
                  read (50,*)  gwwaz_k(i,j,k,l) 
                enddo
             enddo
          enddo
      enddo
      close (50)

      gwwz=gwwz_k(0,0,0)
c
c  redefine koppln.f gauge boson coupling gwwz
c      
      B(3,4,2) = -gwwz_k(0,0,0)
      B(4,2,3) = -gwwz_k(0,0,0)
      B(2,3,4) = -gwwz_k(0,0,0)
      B(2,4,3) =  gwwz_k(0,0,0)
      B(4,3,2) =  gwwz_k(0,0,0)
      B(3,2,4) =  gwwz_k(0,0,0)
c
c  redefine Higgs mass for phasespace adatption
c      
      xm2(6)=w1mass_k(1)**2
c      Print*,"Higgs mass squared is set to ", xm2(6) , " for phasespace generator." 
c
c  Set up boson widths
c
      call widthkk
      xmg(6)=w1mass_k(1)*w1width_k(1)*10d0
c      Print*,"Higgs width information set to ", xmg(6) , " for phasespace generator." 


      END



      subroutine kkcouplcheck
      
      implicit none
      
c
c  Local Variables
      integer i,j,k,l
      character*50 gtext
      double precision h1,h2,h3
c 
c  Global Variables
#include "VBFNLO/utilities/coupl.inc"
#include "kkcoupl.inc"
      open(unit=40, file="kkcheck.dat")
      write(40,*) "Tower height W+/W-   ", kkhw
      write(40,*) "Tower height Z ", kkhz
      write(40,*) "Tower height Z'", kkha
      write(40,*) "Tower height Higgs   ", kkhh
      write(40,*) "--------------------------------------------------------------------"
      do i=0,kkhw
      write (40,*) "W",i+1," -mass  ", w1mass_k(i)
      write (40,*) "W",i+1," -width ", w1width_k(i)
      enddo
      write(40,*) "--------------------------------------------------------------------"
      do i=0,kkhz
      write (40,*)  "Z'",i+1," -mass  ",z1mass_k(i)
      write (40,*)  "Z'",i+1," -width ",z1width_k(i)
      enddo
      write(40,*) "--------------------------------------------------------------------"
      do i=0,kkha
      write (40,*)  "Z'",i," -mass ", a1mass_k(i)
      write (40,*)  "Z'",i," -width ",a1width_k(i)
      enddo
      write(40,*) "--------------------------------------------------------------------"
      if (hswitch) then
      do i=1,kkhh
      write (40,*)  "H",i," -mass  ", h1mass_k(i)
      write (40,*)  "H",i," -width ", h1width_k(i)
      enddo
      write(40,*) "----------q----------------------------------------------------------"
      endif
      do i=0,kkhz
      write (40,*)  "W 1 - W 1 - Z",i+1," -Coupling ",gwwz_k(0,0,i) 
      enddo
!       do i=1,kkhw
!           do j=0,kkhw
!              do k=0,kkhz
!               write (40,*) "W",i+1," - W",j+1," - Z",k+1," -Coupling ", gwwz_k(i,j,k) 
!              enddo
!           enddo
!       enddo
      do i=1,kkhw
              write (40,*) "W",i+1," - W 1 - Z 1 -Coupling ", gwwz_k(i,0,0) 
      enddo
      write(40,*) "--------------------------------------------------------------------"
      do i=0,kkha
          write (40,*) "W 1 - W 1 - A",i," -Coupling ",gwwa_k(0,0,i) 
      enddo
!       do i=1,kkhw
!           do j=0,kkhw
!              do k=0,kkha
!               write (40,*) "W",i+1," - W",j+1," - A",k," -Coupling ",gwwa_k(i,j,k)
!              enddo
!           enddo
!       enddo
      write(40,*) "--------------------------------------------------------------------"
      if(hswitch) then
      do i=0,kkhw
          do j=0,i
             do k=0,kkhh
              write (40,*)  "W",i+1," - W",j+1," - H",k+1," -Coupling ",  gwwh_k(i,j,k) 
             enddo
          enddo
      enddo
      write(40,*) "--------------------------------------------------------------------"
      do i=0,kkhz
          do j=0,i
             do k=0,kkhh
              write (40,*) "Z",i+1," - Z",j+1," - H",k+1," -Coupling ", gzzh_k(i,j,k) 
             enddo
          enddo
      enddo
      write(40,*) "--------------------------------------------------------------------"
      endif
!       do i=0,kkhw
!           do j=0,i
!              do k=0,j
!                 do l=0,k
!                   write (40,*) "W",i+1," - W",j+1," - W",k+1," - W",l+1," -Coupling ",  gwwww_k(i,j,k,l) 
!                 enddo
!              enddo
!           enddo
!       enddo
      write (40,*) "W",1," - W",1," - W",1," - W",1," -Coupling ",  gwwww_k(0,0,0,0)
      write(40,*) "--------------------------------------------------------------------"
!       do k=0,kkhz
!          do l=0,k
             write (40,*) "W 1 - W 1 - Z",1," - Z",1," -Coupling ", gwwzz_k(0,0,0,0) 
!          enddo
!       enddo
!       do i=1,kkhw
!           do j=0,i
!              do k=0,kkhz
!                 do l=0,k
!                   write (40,*) "W",i+1," - W",j+1," - W",k+1," - W",l+1," -Coupling ",  gwwzz_k(i,j,k,l) 
!                 enddo
!              enddo
!           enddo
!       enddo
      write(40,*) "--------------------------------------------------------------------"
!       do k=0,kkhz
!          do l=0,k
             write (40,*) "W 1 - W 1 - A",0," - A",0," -Coupling ", gwwaa_k(0,0,0,0) 
!          enddo
!       enddo
!       do i=1,kkhw
!           do j=0,i
!              do k=0,kkhz
!                 do l=0,k
!                  write (40,*) "W",i+1," - W",j+1," - A",k," - A",l," -Coupling ", gwwaa_k(i,j,k,l) 
!                 enddo
!              enddo
!           enddo
!       enddo
      write(40,*) "--------------------------------------------------------------------"
!       do i=0,kkhw
!           do j=0,i
!              do k=0,kkhz
!                 do l=0,kkhz
!                   write (40,*) "W",i+1," - W",j+1," - A",k," - Z",l+1," -Coupling ", gwwaz_k(i,j,k,l) 
!                 enddo
!              enddo
!           enddo
!       enddo

      write (40,*) "W",1," - W",1," - A",0," - Z",1," -Coupling ", gwwaz_k(0,0,0,0) 
      write(40,*) "--------------------------------------------------------------------"
      write(40,*) "----------------------Sum - Rules ----------------------------------"
      write(40,*) "--------------------------------------------------------------------"
      h1=gwwww_k(0,0,0,0)**2
	  h2=4*wmass**2*gwwww_k(0,0,0,0)**2
	  do i=0,kkhz
      h1=h1-gwwz_k(0,0,i)**2
      h2=h2-3*z1mass_k(i)**2*gwwz_k(0,0,i)**2
	  enddo
      do i=0,kkha
      h1=h1-gwwa_k(0,0,i)**2
      h2=h2-3*a1mass_k(i)**2*gwwa_k(0,0,i)**2
	  enddo
      if (hswitchww) then
      do i=0,kkhh
      h2=h2-wmass**2*gwwh_k(0,0,i)**2
      enddo
      endif
      write(40,*) "W1 W1 -> W1 W1: ~E^4", abs(h1/gwwww_k(0,0,0,0)**2)*100, " %", "     ",
     &            " ~E^2", abs(h2/(4*w1mass_k(0)**2*gwwww_k(0,0,0,0)**2))*100,  " %", "     "
      write(40,*) "--------------------------------------------------------------------"
      h1=gwwzz_k(0,0,0,0)
      h2=2*(z1mass_k(0)**2+w1mass_k(0)**2)*gwwzz_k(0,0,0,0)
      do i=0,kkhw
      h1=h1-gwwz_k(i,0,0)**2
      h2=h2-3*(w1mass_k(i)**2)*gwwz_k(i,0,0)**2+((zmass**2-wmass**2)**2/w1mass_k(i)**2)*gwwz_k(i,0,0)**2
      enddo
      if (hswitchww) then
      do i=0,kkhh
      h2=h2-wmass**2*gwwh_k(0,0,i)*gzzh_k(0,0,i)
      enddo
      endif
      write(40,*) "W1 Z1 -> W1 Z1: ~E^4", abs(h1/gwwzz_k(0,0,0,0))*100, " %", "     ",
     &            " ~E^2", abs(h2/((2*z1mass_k(0)**2+2*w1mass_k(0)**2)*gwwzz_k(0,0,0,0)))*100,  " %", "     "
      write(40,*) "--------------------------------------------------------------------"
      END


!    calculate widths of kk-bosons
!    still using standard width for w+-, z and h

      subroutine widthkk

c    in:       l:  decaying boson W/Z
c              i:  KK-Index of decaying boson
c              j:  KK-Index of decay product
c              k:  kk-Index of decay product
c    out:      width
c
#include "kkcoupl.inc"

      integer i,j,k,l
      double precision width,pi
      Parameter(pi=3.14159265358979)

      do i=1,kkhw
      w1width_k(i)=0d0
      enddo
      do j=1,kkha
      a1width_k(j)=0d0
	  enddo
	  do j=1,kkhz
      z1width_k(j)=0d0
      enddo

      do i=1,kkhw
      do j=0,i-1
      do k=0,kkhz
      if (w1mass_K(i).ge. (w1mass_k(j)+z1mass_k(k))) then

!       w1width_k(i)=w1width_k(i)+(gwwz_k(i,j,k)**2*(((w1mass_k(i) - w1mass_k(j) - z1mass_k(k))*
!      &  (w1mass_k(i) + w1mass_k(j) - z1mass_k(k))*(w1mass_k(i) - w1mass_k(j) + 
!      &   z1mass_k(k))*(w1mass_k(i) + w1mass_k(j) + z1mass_k(k)))/w1mass_k(i)**2)**1.5D0*
!      & -    (w1mass_k(i)**4 + w1mass_k(j)**4 + 10*w1mass_k(j)**2*z1mass_k(k)**2 + 
!      &    z1mass_k(k)**4 + 10*w1mass_k(i)**2*(w1mass_k(j)**2 + z1mass_k(k)**2)))/
!      &    -  (96D0*w1mass_k(i)*w1mass_k(j)**2*z1mass_k(k)**2*(Sqrt((w1mass_k(i)**2 + w1mass_k(j)**2 
!      &  - z1mass_k(k)**2)**2/w1mass_k(i)**2) + Sqrt((w1mass_k(i)**2 - w1mass_k(j)**2 + z1mass_k(k)**2)**2/w1mass_k(i)**2))*Pi)

      w1width_k(i)=w1width_k(i)+(gwwz_k(i,j,k)**2*(((w1mass_k(i) - w1mass_k(j) - z1mass_k(k))
     &    *(w1mass_k(i) + w1mass_k(j) - z1mass_k(k))*
     &    (w1mass_k(i) - w1mass_k(j) + z1mass_k(k))*(w1mass_k(i) + w1mass_k(j) + z1mass_k(k)))/w1mass_k(i)**2)**1.5D0*
     &    (w1mass_k(i)**4 + 4*w1mass_k(j)**4 - 2*w1mass_k(j)**2*z1mass_k(k)**2 
     &    + z1mass_k(k)**4 - 2*w1mass_k(i)**2*(w1mass_k(j)**2 - 5*z1mass_k(k)**2)))/
     &  (  96D0*w1mass_k(i)*w1mass_k(j)**2*z1mass_k(k)**2*(sqrt((w1mass_k(i)**2 
     &  + w1mass_k(j)**2 - z1mass_k(k)**2)**2/w1mass_k(i)**2)+ sqrt((w1mass_k(i)**2 - w1mass_k(j)**2 
     &   + z1mass_k(k)**2)**2/w1mass_k(i)**2))*Pi)

      endif
      enddo
      enddo
      enddo

      do i=1,kkhw
      do j=0,i-1
      do k=1,kkha
      if (w1mass_K(i).ge. (w1mass_k(j)+a1mass_k(k))) then

!       w1width_k(i)=w1width_k(i)+(gwwa_k(i,j,k)**2*(((w1mass_k(i) - w1mass_k(j) - a1mass_k(k))*
!      &  (w1mass_k(i) + w1mass_k(j) - a1mass_k(k))*(w1mass_k(i) - w1mass_k(j) + 
!      &   a1mass_k(k))*(w1mass_k(i) + w1mass_k(j) + a1mass_k(k)))/w1mass_k(i)**2)**1.5D0*
!      & -    (w1mass_k(i)**4 + w1mass_k(j)**4 + 10*w1mass_k(j)**2*a1mass_k(k)**2 + 
!      &    a1mass_k(k)**4 + 10*w1mass_k(i)**2*(w1mass_k(j)**2 + a1mass_k(k)**2)))/
!      &    -  (96D0*w1mass_k(i)*w1mass_k(j)**2*a1mass_k(k)**2*(Sqrt((w1mass_k(i)**2 + w1mass_k(j)**2 
!      &  - a1mass_k(k)**2)**2/w1mass_k(i)**2) + Sqrt((w1mass_k(i)**2 - w1mass_k(j)**2 + a1mass_k(k)**2)**2/w1mass_k(i)**2))*Pi)
    
      w1width_k(i)=w1width_k(i)+(gwwa_k(i,j,k)**2*(((w1mass_k(i) - w1mass_k(j) - a1mass_k(k))
     &    *(w1mass_k(i) + w1mass_k(j) - a1mass_k(k))*
     &    (w1mass_k(i) - w1mass_k(j) + a1mass_k(k))*(w1mass_k(i) + w1mass_k(j) + a1mass_k(k)))/w1mass_k(i)**2)**1.5D0*
     &    (w1mass_k(i)**4 + 4*w1mass_k(j)**4 - 2*w1mass_k(j)**2*a1mass_k(k)**2 
     &    + a1mass_k(k)**4 - 2*w1mass_k(i)**2*(w1mass_k(j)**2 - 5*a1mass_k(k)**2)))/
     &  (  96D0*w1mass_k(i)*w1mass_k(j)**2*a1mass_k(k)**2*(sqrt((w1mass_k(i)**2 
     &  + w1mass_k(j)**2 - a1mass_k(k)**2)**2/w1mass_k(i)**2)+ sqrt((w1mass_k(i)**2 - w1mass_k(j)**2 
     &   + a1mass_k(k)**2)**2/w1mass_k(i)**2))*Pi)


      endif
      enddo
      enddo
      enddo


      do i=1,kkhz
      do k=0,kkhw
      do j=0,k
      if (z1mass_K(i).ge. (w1mass_k(j)+w1mass_k(k))) then

      z1width_k(i)=z1width_k(i)+(gwwz_k(k,j,i)**2*(((w1mass_k(j) - w1mass_k(k) - z1mass_k(i))*(w1mass_k(j) + w1mass_k(k) 
     &   - z1mass_k(i))*(w1mass_k(j) - w1mass_k(k) + z1mass_k(i))*(w1mass_k(j) + w1mass_k(k) + 
     &  z1mass_k(i)))/z1mass_k(i)**2)**1.5D0*
     &  - (w1mass_k(j)**4 + w1mass_k(k)**4 + 10*w1mass_k(k)**2*z1mass_k(i)**2 + 
     &  z1mass_k(i)**4 + 10*w1mass_k(j)**2*(w1mass_k(k)**2 + z1mass_k(i)**2)))/
     &  -  (96D0*w1mass_k(j)**2*w1mass_k(k)**2*z1mass_k(i)*(Sqrt((w1mass_k(j)**2 
     &  - w1mass_k(k)**2 + z1mass_k(i)**2)**2/z1mass_k(i)**2) + 
     &  Sqrt((-w1mass_k(j)**2 + w1mass_k(k)**2 + z1mass_k(i)**2)**2/z1mass_k(i)**2))*Pi)

      endif
      enddo
      enddo
      enddo
      do i=1,kkha
      do k=0,kkhw
      do j=0,k
      if (a1mass_K(i).ge. (w1mass_k(j)+w1mass_k(k))) then

      a1width_k(i)=a1width_k(i)+((gwwa_k(k,j,i)**2*(((w1mass_k(j) - w1mass_k(k) - a1mass_k(i))*(w1mass_k(j) + w1mass_k(k) 
     &   - a1mass_k(i))*(w1mass_k(j) - w1mass_k(k) + a1mass_k(i))*(w1mass_k(j) + w1mass_k(k) + 
     &  a1mass_k(i)))/a1mass_k(i)**2)**1.5D0*
     &  - (w1mass_k(j)**4 + w1mass_k(k)**4 + 10*w1mass_k(k)**2*a1mass_k(i)**2 + 
     &  a1mass_k(i)**4 + 10*w1mass_k(j)**2*(w1mass_k(k)**2 + a1mass_k(i)**2)))/
     &  -  (96D0*w1mass_k(j)**2*w1mass_k(k)**2*a1mass_k(i)*(Sqrt((w1mass_k(j)**2 
     &  - w1mass_k(k)**2 + a1mass_k(i)**2)**2/a1mass_k(i)**2) + 
     &  Sqrt((-w1mass_k(j)**2 + w1mass_k(k)**2 + a1mass_k(i)**2)**2/a1mass_k(i)**2))*Pi))

      endif
      enddo
      enddo
      enddo
      END

     
      subroutine kk_coupl_inp
      
      implicit none
      
c
c  Local Variables
      double precision kk1,kk2,kk3,kk4,kk5,kk6,kk7,kk8,kk9,rdwn,
     & kk10,gwwak1,gwwk1z,gwwk1a,gwwww,gwwzz,gwwzk1,z1width,w1width,a1width,z1mass,w1mass,a1mass
      double precision inp1,inp2,pi,h1,h2
      parameter(pi =3.141592653589793d0)
      integer*4 k,i,kkmaxw,kkmaxz,kkmaxg
      logical vbfcalcswitch
c
c  Global Variables
#include "VBFNLO/utilities/coupl.inc"
#include "kkcoupl.inc"

      open (unit=49,file="kk_input.dat")
      read(49,*) vbfcalcswitch 
      read(49,*) rdwn
      read(49,*) kkmaxw
      read(49,*) kkmaxz
      read(49,*) kkmaxg
      close(49)
!       kkmaxw=kkmaxw!+1
!       kkmaxz=kkmaxz!+1
!       kkmaxg=kkmaxg!+1
       
      Print*, "**************************************************"
      Print*, "Initiated Warped Higgsless Calculation"
      Print*, "**************************************************"
      Print*, "ALL PREVIOUS HIGGS-RELATED INFORMATION IS OBSOLETE"
      Print*, "**************************************************"
      if (vbfcalcswitch) then
      Print*, "Couplings and Kaluza-Klein masses are calculated by VBFNLO"
      Print*, "Kaluza-Klein related Information is written to"
      Print*, "kk_coupl_inp.dat:  Parameters included in the proceeding run"
      Print*, "kkcheck.dat:  Kaluza-Klein information and relative sum rule violation"
      Print*, "**************************************************"

c
c
c   C++ Calculation of Couplings and Masses
       
      Call calckkcoupl( gwwa , wmass, zmass, rdwn, kkmaxw, kkmaxz, kkmaxg )

      else
      Print*, "MANUAL INPUT OF COUPLINGS MASSES"
      Print*, "Kaluza-Klein related Information is written to"
      Print*, "kk_coupl_inp.dat:  Parameters included in the proceeding run"
      Print*, "kkcheck.dat:  Kaluza-Klein information and relative sum rule violation"
      Print*, "**************************************************"
      ENDIF
c
c  Read in Parameters from kk_input.dat
c  
      Call kk_coupl_inp_man

c     
c
c  Sum-Rules WW -> WW
c

      kk1=0d0
      kk2=0d0
      do k=0,kkhz-1
      kk1= gwwz_k(0,0,k)**2+kk1
      kk2=kk2+3*z1mass_k(k)**2*gwwz_k(0,0,k)**2
      enddo
      do k=0,kkha
      kk1= gwwa_k(0,0,k)**2+kk1
      kk2=kk2+3*a1mass_k(k)**2*gwwa_k(0,0,k)**2
      enddo
      
      gwwz_k(0,0,kkhz)=sqrt((4d0*wmass**2*kk1-kk2)/(3d0*z1mass_k(kkhz)**2-4*wmass**2))
	  
      gwwww_k(0,0,0,0)=sqrt(kk1+gwwz_k(0,0,kkhz)**2)
	  
c     
c  Sum-Rules WZ -> WZ
c
      kk1=0d0
      do k=0,kkhw-1
      kk1=kk1+2*(wmass**2+zmass**2)*gwwz_k(k,0,0)**2
      enddo
      kk2=0d0
      kk3=zmass**2-wmass**2
      do k=0,kkhw-1
      kk2=kk2+gwwz_k(k,0,0)**2*(3*w1mass_k(k)**2-(kk3**2/w1mass_k(k)**2))
      enddo
      kk4=3*w1mass_k(kkhw)**2 - (kk3**2/w1mass_k(kkhw)**2) -2d0*(wmass**2+zmass**2)
      gwwz_k(kkhw,0,0)=sqrt((kk1-kk2)/kk4)
      
      gwwzz_k(0,0,0,0)=0d0
      do k=0,kkhw
      gwwzz_k(0,0,0,0)=gwwzz_k(0,0,0,0)+gwwz_k(k,0,0)**2
      print*, gwwzz_k(0,0,0,0)
      enddo

c
c
c  Sum-Rules AZ -> WW
c      
      gwwaz_k(0,0,0,0)=gwwa*gwwz
c
c  Sum-Rules AA -> WW
c      
      gwwaa_k(0,0,0,0)=gwwa**2

c
c  Dump Kaluza-Klein Information
c
      call kkcouplcheck


      END



      


      
      
      
      
      
      





	
