#include <iostream>
#include "stdio.h"
#include "TH1F.h" 
#include "TFile.h"

using namespace std;

extern "C" 
{
  void openrootsession_(char*, int);
  void closerootsession_();
  void createroothisto_(int*, char*, int*, double*, double*, int);
  void fillroothisto_(int*, double*, double*);
}

namespace roothists {
  int max_jets;
  TObjArray* Hlist;
  TString rootfile;
  TFile *hfile;
}

using namespace roothists;

void openrootsession_(char* file, int len)
{
  
  rootfile.Resize(0);
  rootfile.Append(file);
  int siz = rootfile.Index(' ');
  rootfile.Resize(siz);

  Hlist = new TObjArray(0);
  hfile = new TFile(rootfile,"recreate");
  hfile->cd();
  return;
}

void closerootsession_()
{
  hfile->cd();
  if (Hlist->GetEntries() > 0 )  {
    Hlist->Write();
    hfile->Close();
  }
  std::cout << "PARAM = " <<max_jets<<endl;
  return;
}

void createroothisto_(int* ID, char* title, int* bins, double* min, double* max, int len)
{
  char name[10];
  TString htitle(title);
  int siz = htitle.Index("    ");
  htitle.Resize(siz);
  sprintf( name, "H%d", *ID );
  hfile->cd();
  TH1F* histo = new TH1F(name, htitle, *bins, *min, *max);
  Hlist->Add(histo);
  return;
}

void fillroothisto_(int* ID, double* value, double* weight)
{
  char name[10];
  sprintf( name, "H%d", *ID );
  hfile->cd();
  TH1F* histo = (TH1F*)Hlist->FindObject(name);
  if (histo != 0) {
    histo->Fill(*value, *weight);
  }
}



