c
c     Simon Wendel :     sw@particle.uni-karlsruhe.de
c     Last modified:    2008 June 23
c
      real*8 function m2s_stpz(
     &                   xi,     !in:  Feynman x parameters of incoming fermions
     &                    p,     !in:  momenta associated with external partons
     &                    v     !in:  momenta associated with decay leptons
     &                        )
      implicit none
c
c declare input/output variables
c
#include "VBFNLO/utilities/global.inc"

      integer i, mu, fsign(max_p+max_v), count , maxcount
      double precision xi(nx), q_sf, pdf(-6:6,2)
      double precision p(0:3,max_p),v(0:3,max_v), pbar(0:3,max_p+max_v)
      double precision r(0:3), tmpa(1,2), tmpb(1,2) , help(0:3)
      double precision mass2, processes2
c      double precision test(0:3)
c      double precision boostacc, ampacc, boosum, ampsum(2,2), boo, updf,dpdf,spdf,cpdf
c      double precision maxboostacc,maxampacc, maxampfault
c      Parameter (maxcount=100000)! lorentz invarianz test ist done maxcount times, summary printed at the end
c      Parameter (maxboostacc=5.0d-7, maxampacc=1.0d-4)
cWarning printed, if ampacc>maxampacc,same for boost. debug variables : count, maxcount, test, ampacc,boosum,ampsum,mass2,boo,maxboostacc,maxamacc,maxampfault
c      DATA count /0/
c      DATA boo,maxampfault /4.0D0,0d0/   !boo=boost rapidiy for Lorentz invarianz test
c      DATA boosum /0d0/
c      DATA ampsum(1,1), ampsum(1,2), ampsum(2,1), ampsum(2,2) /0D0,0D0,0D0,0D0/
c      DATA updf,spdf,spdf,cpdf /0D0,0D0,0D0,0D0/
      external mass2

      real*8 alphas, xmt
      common /bkopin/ alphas, xmt
c
c alfas, scales etc
#include "VBFNLO/utilities/scales.inc"

c fill pbar with external momenta      
      do mu= 0, 3
         do i = 1, n_p
            pbar(mu,i) = p(mu,i)
         enddo
         do i = 1, n_v
            pbar(mu,n_p+i) = v(mu,i)
         enddo
      enddo

c calc pdfs
      q_sf = sqrt(mufsq(1,1))
      call pdfproton( xi(1), q_sf, pdf(-6,1) ) ! f_a(x1)
      q_sf = sqrt(mufsq(2,1))
      call pdfproton( xi(2), q_sf, pdf(-6,2) ) ! f_a(x2)
      q_sf = xmt/4d0 * xif
      
      do i=-6, 6
         pdf(i,1) = pdf(i,1)/xi(1)
         pdf(i,2) = pdf(i,2)/xi(2)

c         print*, "pdf(",i," ,1):", pdf(i,1)
c         print*, "pdf(",i," ,2):", pdf(i,2)
      enddo


cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c                                                                      c
c                  pdflib standards                                    c 
c                                                                      c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc      
c     pdfproton returns x*f(x)
c     pdf(1,) = d
c     pdf(2,) = u
c     pdf(3,) = s
c     pdf(4,) = c
c     pdf(5,) = b
c     pdf(6,) = t = 0
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c                                                                      c
c                   single top production                              c
c                                                                      c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  FOR PROCESSES  : u b -> d b e+ e- mu+ num / db~-->ub~e+e-mu-num~
      do i = 1, n_p+n_v
         fsign(i) = 1
      enddo

      fsign(5) = - 1
      fsign(7) = - 1
c         fsign contains information about particle/antiparticle state (-1=antiparticle)
      call DOUBLESMATRIX(pbar, fsign, tmpa) 
c  tmpa : the two 2 summed/squared/averaged M^2 for ub-->dbe+e-mu+num and db~-->ub~e+e-mu-num~ 

ccccc lorentz invariance test part 1 ccccccccccccccc
cccccccccccccccccccccccccccccccccccccccccccccccccccc          

c      if (count .LE. maxcount) then
c        count = count + 1

c	print*, "------------ new event"
c	do i = 1,n_p+n_v
c	print*,"fsign(",i,")=", fsign(i)  
c	enddo
c	do i = 1,2
c	print*,"tmpa(1,",i,")=", tmpa(1,i)  
c	enddo

c        do i = 0, 4
c           test(i) = pbar(i,5)+pbar(i,6)
c        enddo         
c        boostacc = mass2(test)
	
c        do i = 1, 8
c           call boostl(boo, pbar(0,i))        ! boost with rapidity boo
c        enddo

c        do i = 0, 4
c           test(i) = pbar(i,5)+pbar(i,6)
c        enddo         
	
c        boostacc = mass2(test)/boostacc - 1
	
c	if (boostacc .gt. maxboostacc)	then
c	print*,"--- WARNING --- boostacc=",boostacc," at count",count
c	endif
	
c	call DOUBLESMATRIX(pbar, fsign, tmpb)            

c        do i = 1, 2
c	   ampacc = abs( tmpa(1,i) / tmpb(1,i) - 1d0 )
c           ampsum(i,1) = ampsum(i,1) + ampacc
c	   if (ampacc .gt. maxampacc)	then
c	   print*,"--- WARNING --- ampacc=(",i,")=",ampacc," at count",count
c	   if (ampacc .gt. maxampfault) then
c	   maxampfault=ampacc
c	   endif
c	   endif
c       enddo
c        boosum = boosum + boostacc


c         updf=updf+pdf(2,1)*xi(1)+pdf(2,2)*xi(2)
c         dpdf=dpdf+pdf(1,1)*xi(1)+pdf(1,2)*xi(2)
c         spdf=spdf+pdf(3,1)*xi(1)+pdf(3,2)*xi(2)
c         cpdf=cpdf+pdf(4,1)*xi(1)+pdf(4,2)*xi(2)

c        if (count.eq.maxcount) then
c	  print*,"  ",maxcount," Boostacc SUM ", boosum/count
c	  do i = 1, 2
c          print*,"  ",maxcount," AMP acc SUM",i, ampsum(i,1)/count
c          enddo
c          print*,"  ",maxcount,"updf average",updf/(maxcount*2) 
c          print*,"  ",maxcount,"dpdf average",dpdf/(maxcount*2)
c          print*,"  ",maxcount,"spdf average",spdf/(maxcount*2)
c          print*,"  ",maxcount,"cpdf average",cpdf/(maxcount*2)
c        endif
	
c	do i = 1, 8
c           call boostl(-boo, pbar(0,i))        ! boost back
c        enddo
c      endif

ccccccccccccccEnd lorentz test, part 1 ccccccccccccc
cccccccccccccccccccccccccccccccccccccccccccccccccccc

      call switchmom( pbar(0,1), pbar(0,2) )

c switch momenta of inital quarks

      call DOUBLESMATRIX(pbar, fsign, tmpb) 

c  tmpb : the two summed,squared, averaged M²  for bu-->dbe+e-mu+num and b~d-->ub~e+e-mu-num~ 

      m2s_stpz = 0d0

c  sum up all processes of both flavours with initial {u,b} , {d,b~}, weighted with suitable pdfs

      m2s_stpz = m2s_stpz + processes2(pdf,tmpa,tmpb,0) 

c restore the incoming momenta

      call switchmom( pbar(0,1), pbar(0,2) )   
cccccccccccccccccccccccccccccccccccccccccccccc

c CROSSING FOR PROCESSES : d~ b -> u~ b e+ e- mu+ num / u~b~-->d~b~e+e-mu-num~

      fsign(1) = - 1
      fsign(3) = - 1

      call switchmom( pbar(0,1), pbar(0,3) )  

      call DOUBLESMATRIX(pbar, fsign, tmpa)

c  tmpa : the two 2 summed/squared/averaged M^2 for crossed processes
c           d~b-->u~be+e-mu+num and db~-->ub~e+e-mu-num~      
      
ccccc lorentz invariance test part 2 ccccccccccccccc
cccccccccccccccccccccccccccccccccccccccccccccccccccc          
      
c      if (count .LE. maxcount) then

c        print*," *** CROSSED PROCESSES ***"
c	do i=1,2
c        print*,"CROSSED tmpa(1,",i,")=", tmpa(1,i)  
c	enddo

c        do i = 0, 4
c           test(i) = pbar(i,7)+pbar(i,8)
c        enddo         
c        boostacc = mass2(test)

c        do i = 1, 8
c          call boostl(boo, pbar(0,i))
c        enddo
	
c        do i = 0, 4
c           test(i) = pbar(i,7)+pbar(i,8)
c        enddo         

c         boostacc = mass2(test)/boostacc

c       if (boostacc .gt. maxboostacc)	then
c	print*,"--- WARNING --- CROSSED boostacc=",boostacc," at count",count
c	endif
	
c	call DOUBLESMATRIX(pbar, fsign, tmpb)

c        do i = 1, 2
c	   ampacc = abs( tmpa(1,i) / tmpb(1,i) - 1 )
c           ampsum(i,2) = ampsum(i,2) + ampacc
c  	   if (ampacc .gt. maxampacc)	then
c	   print*,"--- WARNING --- CROSSED ampacc=(",i,")=",ampacc," at count",count
c	   endif
c	   if (ampacc .gt. maxampfault) then
c	   maxampfault=ampacc
c	   endif
c        enddo

c	boosum = boosum + boostacc
c        if (count.eq.maxcount) then
c	 print*,maxcount," Boostacc CROSSED SUM ", boosum/count
c         do i = 1, 2
c            print*,maxcount," AMPacc CROSSED SUM",i, ampsum(i,2)/count
c         enddo
c	 print*,"Max amplitude fault : ",maxampfault
c        endif 
c      endif

ccccc end lorentz invariance test part 2 ccccccccccc
cccccccccccccccccccccccccccccccccccccccccccccccccccc

      call switchmom( pbar(0,1), pbar(0,3) )  
      call switchmom( pbar(0,1), pbar(0,2) )  
      call switchmom( pbar(0,1), pbar(0,3) ) 

      call DOUBLESMATRIX(pbar, fsign, tmpb)

c  tmpb : the two 2 summed/squared/averaged M^2 for crossed processes
c           bd~-->u~be+e-mu+num and b~d-->ub~e+e-mu-num~      

c  sum up all processes of both flavours with initial {d~,b} , {u~,b~}, weighted with suitable pdfs

      m2s_stpz = m2s_stpz + processes2(pdf,tmpa,tmpb,1) 
      
      return
      end



      double precision function processes2(pdf,tmpa,tmpb,crossed)

ccccccccccccccccccccccccccccccc
c
c  returns the sum of 8 Subprocesses , multiplicated with suitable pdfs
c
c  for crossed=0  :  all processes of  both flavours with initial ub,db~ and switched 
c  for crossed=1  :  all processes of  both flavours with initial d~b,u~b~ and switched 
c
ccccccccccccccccccccccccccccccc  

c  crossed=0 for usual processes (initial {ub}, {db~})
c  crossed=1 for crossed processes(initial {d~b}, {u~b~})

      implicit none

#include "VBFNLO/utilities/process.inc"

      integer crossed , bsign , i
      double precision pdf(-6:6,2), tmpa(1,2), tmpb(1,2)
      processes2 = 0d0

      SELECT CASE(process)
c         CASE(EWtZj_Wp)
c            i=0
c         CASE(EWtZj_Wm)
c            i=1
         CASE DEFAULT
            print*,""
            print*,"m2s_stpz has been accidentially called by proc: ",process
            print*,""
            stop
      END SELECT

c     ! i=0 --> only W+Z , i=1 --> only W-Z, see above!
      bsign=1-2*i
      processes2 = processes2 + tmpa(1,i+1) * pdf(2-i-3*crossed,1) * pdf(bsign*5,2) 
      processes2 = processes2 + tmpa(1,i+1) * pdf(4-i-7*crossed,1) * pdf(bsign*5,2)

      processes2 = processes2 + tmpb(1,i+1) * pdf(bsign*5,1) * pdf(2-i-3*crossed,2) 
      processes2 = processes2 + tmpb(1,i+1) * pdf(bsign*5,1) * pdf(4-i-7*crossed,2) 
         
      processes2 = processes2 ! 
  
      return
      end function

